/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ustasoft.pos.service;

import pos.ar.*;
import com.ustasoft.component.GeneralFunction;
import com.ustasoft.pos.dao.jdbc.AccCoaDao;
import com.ustasoft.pos.domain.view.AccCoaView;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.sql.Connection;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JComboBox;
import org.jdesktop.swingx.autocomplete.AutoCompleteDecorator;
import pos.MainForm;

/**
 *
 * @author cak-ust
 */
public class FrmRptBankGL extends javax.swing.JInternalFrame {
    private GeneralFunction fn=new GeneralFunction();
    ReportService service;
    private Connection conn;
    List lstCoa=new ArrayList();
    /**
     * Creates new form FrmRptPenjualan
     */
    public FrmRptBankGL() {
        initComponents();
        AutoCompleteDecorator.decorate(cmbAkun);
        MyKeyListener kListener=new MyKeyListener();
        fn.addKeyListenerInContainer(jPanel1, kListener, null);
        fn.addKeyListenerInContainer(panelParameter, kListener, null);
        jTree1.setExpandsSelectedPaths(false);
        jTree1.setRootVisible(false);
//        jTree1.setShowsRootHandles(true);
        for (int i=0; i<jTree1.getRowCount(); i++)
		jTree1.expandRow (i);

//        jTree1.setSelectionRow(1);
    }
    
    public void setConn(Connection con){
        this.conn=con;
    }

    private void initForm(){
        try {
            service=new ReportService(conn, this);
            
            Timestamp skg=fn.getTimeServer();
            jDateChooserAwal.setDate(skg); jDateChooserAwal.setFormats(MainForm.sDateFormat);
            jDateChooserAkhir.setDate(skg);jDateChooserAkhir.setFormats(MainForm.sDateFormat);
            jTree1.setSelectionRow(0);
//            jSpinner1.setValue(new Integer(fn.yyyymmdd_format.format(skg).substring(0, 4)));
            cmbBulan.setSelectedIndex(new Integer(fn.yyyymmdd_format.format(skg).substring(5, 7))-1);
            cmbAkun.removeAllItems();
            lstCoa.add("");
            cmbAkun.addItem("");
            AccCoaDao rel=new AccCoaDao(conn);
            for(AccCoaView view: rel.cariSemuaCoa("")){
                lstCoa.add(view.getAcc_no());
                cmbAkun.addItem(view.getAcc_name()+" - "+view.getAcc_no());
            }
            
        } catch (Exception ex) {
            Logger.getLogger(FrmRptPenjualan.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    private class MyKeyListener extends KeyAdapter{
        @Override
        public void keyPressed(KeyEvent evt) {
            if(evt.getKeyCode()==KeyEvent.VK_DELETE && (
                    evt.getSource()==cmbAkun 
                    ) ){
                ((JComboBox)evt.getSource()).setSelectedIndex(0);
            }
        }
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        panelParameter = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        cmbAkun = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        panelTanggal = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jDateChooserAkhir = new org.jdesktop.swingx.JXDatePicker();
        jDateChooserAwal = new org.jdesktop.swingx.JXDatePicker();
        panelBulan = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        cmbBulan = new javax.swing.JComboBox();
        jYearChooser1 = new com.toedter.calendar.JYearChooser();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();

        setClosable(true);
        setTitle("Laporan Hutang - Piutang");
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameOpened(evt);
            }
        });

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        panelParameter.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameter"));
        panelParameter.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel4.setText("Akun : ");
        panelParameter.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(15, 70, 75, 20));

        panelParameter.add(cmbAkun, new org.netbeans.lib.awtextra.AbsoluteConstraints(85, 70, 220, -1));

        jPanel2.setLayout(new java.awt.CardLayout());

        jLabel2.setText("Awal :");

        jLabel3.setText("Sampai :");

        javax.swing.GroupLayout panelTanggalLayout = new javax.swing.GroupLayout(panelTanggal);
        panelTanggal.setLayout(panelTanggalLayout);
        panelTanggalLayout.setHorizontalGroup(
            panelTanggalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTanggalLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelTanggalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelTanggalLayout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jDateChooserAwal, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelTanggalLayout.createSequentialGroup()
                        .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jDateChooserAkhir, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(70, Short.MAX_VALUE))
        );
        panelTanggalLayout.setVerticalGroup(
            panelTanggalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTanggalLayout.createSequentialGroup()
                .addGroup(panelTanggalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jDateChooserAwal, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(3, 3, 3)
                .addGroup(panelTanggalLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jDateChooserAkhir, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 8, Short.MAX_VALUE))
        );

        jPanel2.add(panelTanggal, "card2");

        jLabel5.setText("Bulan :");

        cmbBulan.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Januari", "Februari", "Maret", "April", "Mei", "Juni", "Juli", "Agustus", "September", "Oktober", "November", "Desember" }));

        javax.swing.GroupLayout panelBulanLayout = new javax.swing.GroupLayout(panelBulan);
        panelBulan.setLayout(panelBulanLayout);
        panelBulanLayout.setHorizontalGroup(
            panelBulanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBulanLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cmbBulan, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jYearChooser1, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                .addContainerGap())
        );
        panelBulanLayout.setVerticalGroup(
            panelBulanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBulanLayout.createSequentialGroup()
                .addGroup(panelBulanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelBulanLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(cmbBulan, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jYearChooser1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 35, Short.MAX_VALUE))
        );

        jPanel2.add(panelBulan, "card3");

        panelParameter.add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 15, 315, 55));

        jPanel1.add(panelParameter, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 330, 200));

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/printer.png"))); // NOI18N
        jButton1.setText("Tampilkan");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(135, 225, 105, 30));

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/cancel.png"))); // NOI18N
        jButton2.setText("Tutup");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 225, 90, 30));

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Laporan");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Kas & Bank");
        javax.swing.tree.DefaultMutableTreeNode treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Daftar Akun Kas & Bank");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Buku Bank");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Detail Penerimaan Lain");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Ringkasan Penerimaan Lain");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Detail Pembayaran Lain");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Ringkasan Pembayaran Lain");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Buku Besar");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Bukti Jurnal Umum");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Buku Besar (Detail)");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Neraca Saldo");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Neraca Lajur");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Laporan Laba Rugi");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Neraca");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("Jurnal Kas Harian");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jTree1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 269, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 345, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 263, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );

        setBounds(0, 0, 646, 316);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        udfPreview();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void formInternalFrameOpened(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameOpened
        initForm();;
    }//GEN-LAST:event_formInternalFrameOpened

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        String s=jTree1.getSelectionModel().getLeadSelectionPath().getLastPathComponent().toString();
        jLabel2.setText(s.equalsIgnoreCase("Daftar Akun Kas & Bank")? "Per": "Awal");
        jDateChooserAkhir.setVisible(!s.equalsIgnoreCase("Daftar Akun Kas & Bank"));
        jLabel3.setVisible(jDateChooserAkhir.isVisible());
        cmbAkun.setVisible(s.equalsIgnoreCase("Buku Bank")||s.equalsIgnoreCase("Buku Besar (Detail)")||
                s.equalsIgnoreCase("Jurnal Kas Harian"));
        jLabel4.setVisible(cmbAkun.isVisible());
        panelBulan.setVisible(s.equalsIgnoreCase("Laporan Laba Rugi")||s.equalsIgnoreCase("Neraca"));
        panelTanggal.setVisible(!panelBulan.isVisible());
        
    }//GEN-LAST:event_jTree1ValueChanged
    SimpleDateFormat fmt=new SimpleDateFormat("yyyy-MM-dd");
    
    private void udfPreview(){
        HashMap param=new HashMap();
        param.put("toko", MainForm.sToko);
        param.put("alamat1", MainForm.sAlamat1);
        param.put("alamat2", MainForm.sAlamat2);
        param.put("telp", MainForm.sTelp1);
        param.put("email", MainForm.sEmail);
        param.put("tanggal1", fmt.format(jDateChooserAwal.getDate()));
        param.put("tanggal2", fmt.format(jDateChooserAkhir.getDate()));
        param.put("accNo", cmbAkun.getSelectedIndex()==0? "": lstCoa.get(cmbAkun.getSelectedIndex()).toString());
        param.put("accName", cmbAkun.getSelectedIndex()==0? "Semua Akun": cmbAkun.getSelectedItem().toString());
        Double d=new Double(0);
        
        String pilih =jTree1.getSelectionModel().getLeadSelectionPath().getLastPathComponent().toString();
        if(pilih.equalsIgnoreCase("Daftar Akun Kas & Bank")){
            service.udfPreview(param, "AccKasBankList", null);    
        }
        if(pilih.equalsIgnoreCase("Buku Bank")){
            service.udfPreview(param, "AccBukuBank", null);    
        }
        if(pilih.equalsIgnoreCase("Detail Penerimaan Lain")){
            param.put("tipe", "BKM");
            service.udfPreview(param, "AccBuktiKasDetail2", null);    
        }
        if(pilih.equalsIgnoreCase("Ringkasan Penerimaan Lain")){
            param.put("tipe", "BKM");
            service.udfPreview(param, "AccBuktiKasRekap", null);    
        }
        if(pilih.equalsIgnoreCase("Detail Pembayaran Lain")){
            param.put("tipe", "BKK");
            service.udfPreview(param, "AccBuktiKasDetail2", null);    
        }
        if(pilih.equalsIgnoreCase("Ringkasan Pembayaran Lain")){
            param.put("tipe", "BKK");
            service.udfPreview(param, "AccBuktiKasRekap", null);    
        }
        //---------------------------------------------
        if(pilih.equalsIgnoreCase("Bukti Jurnal Umum")){
            service.udfPreview(param, "AccJournalDet", null);    
        }
        if(pilih.equalsIgnoreCase("Buku Besar (Detail)")){
            service.udfPreview(param, "GLDet", null);    
        }
        if(pilih.equalsIgnoreCase("Neraca Saldo")){
            service.udfPreview(param, "NeracaSaldo", null);    
        }
        if(pilih.equalsIgnoreCase("Neraca Lajur")){
            service.udfPreview(param, "NeracaLajur_v1", null);    
        }
        if(pilih.equalsIgnoreCase("Laporan Laba Rugi")){
            param.put("bulan", new DecimalFormat("00").format(cmbBulan.getSelectedIndex()+1));
            param.put("namaBulan", cmbBulan.getSelectedItem().toString());
            param.put("tahun", String.valueOf(jYearChooser1.getValue()));
            service.udfPreview(param, "AccLabaRugi", null);    
        }
        if(pilih.equalsIgnoreCase("Neraca")){
            param.put("bulan", new DecimalFormat("00").format(cmbBulan.getSelectedIndex()+1));
            param.put("namaBulan", cmbBulan.getSelectedItem().toString());
            param.put("tahun", String.valueOf(jYearChooser1.getValue()));
            service.udfPreviewNeraca(String.valueOf(jYearChooser1.getValue()), 
                    new DecimalFormat("00").format(cmbBulan.getSelectedIndex()+1), 
                    this);    
        }
        if(pilih.equalsIgnoreCase("Jurnal Kas Harian")){
            service.udfPreview(param, "AccJurnalKasHarian", null);    
        }
//          
//  Neraca Saldo
//  Neraca Lajur
//  Laporan Rugi Laba
//  Neraca
//  Jurnal Kas Harian

//            case 3:{
//                service.udfPreview(param, "ArReceiptDetail", null);    break;
//            }
//            case 4:{
//                service.udfPreview(param, "ApPaymentDetail", null);    break;
//            }
//            
//            default:{
//                break;
//            }
//        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox cmbAkun;
    private javax.swing.JComboBox cmbBulan;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private org.jdesktop.swingx.JXDatePicker jDateChooserAkhir;
    private org.jdesktop.swingx.JXDatePicker jDateChooserAwal;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTree jTree1;
    private com.toedter.calendar.JYearChooser jYearChooser1;
    private javax.swing.JPanel panelBulan;
    private javax.swing.JPanel panelParameter;
    private javax.swing.JPanel panelTanggal;
    // End of variables declaration//GEN-END:variables
}
